
#define	PDC_DLL_BUILD
#define	_AMD64_
#include <windows.h>
#include <winuser.h>
#include <curses.h>
#define	BLUE 1
#define	PDC_NCMOUSE 1

struct passed {
    int	todo;	    // what to do code
//			  0 = initialize
//			  1 = draw base	screen after init
//			  2 = read keystroke
//			  3 = move cursort to x,y and set cursor size
//			  4 = write towrite string at x,y with color pair color	with cursor type cursor
//			 10 = draw box
//			 99 = close down
    int	key;	  // &PE3key  keystroke	returned
    int	x;	  // &PE3x    x	coordinate of cursor  (in and out)
    int	y;	  // &PE3y    y	coordinate of cursor  (in and out)
    int	bc;	  // &PE3bc   color of box
    int	xx;	  // &PE3xx   xx second	coordinate as needed
    int	yy;	  // &PE3yy   yy second	coordinate as needed
    int	xmax;	  // &PE3xmax current horizontal size returned on resize or init
    int	ymax;	  // &PE3ymax current vertical size returned on	resize or init
    int	cur;	  // &PE3cur  cursor type
    int	col;	  // &PE3col  color to write
    int	len;	  // length of string:
    char *towrite;// character string to write
};

int x,y,xx,yy,xmax,ymax,rc;
WINDOW *myscreen;

    // some code page 437 box characters, add 65536 to get proper ACS character	to display
    // non-ascii characters are	printed	as checker block
    char xlat[256]={ 97, 97, 97, 97, 97, 97, 97, 97, 44, 43, 97, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		      0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		     97, 97, 97,120,117, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,107,
		    109,118,119,116,113,110, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97,106,108, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97,
		     97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97, 97};






bool rcck(int n,int rc)	{	// return code checker
    if (rc==0) {
	n=n;
    } else {
	fprintf(stdout,"rc= %d at %d \n",rc,n);
	return(TRUE);
    }
    return(FALSE);
}

void subinit() { // write basic	screen window for specified pane (x,y) to (xx,yy)

//fprintf(stdout,"subinit x=%d y=%d xx=%d yy=%d	xmax=%d	ymax=%d	\n",x,y,xx,yy,xmax,ymax);
    int	j,k;
    rcck(7,bkgd(COLOR_PAIR(1)));

    for	(j=x;j<min(xx,xmax);j++) {
	for (k=y;k<min(yy-3,ymax);k++) {
	    if (rcck(8,move(k,j))) {
//fprintf(stdout,"out of bounds	j=%d k=%d xmax=%d ymax=%d\n",j,k,xmax,ymax);
	    }
	    rcck(9,attrset(COLOR_PAIR(1)));
	    rcck(10,addch(' '));
	}
	if ( rcck(11,move(yy-3,j)) ) {
//fprintf(stdout,"11 j=%d yy-3=%d xmax=%d ymax=%d\n",j,yy-3,xmax,ymax);
	}
	rcck(12,attrset(COLOR_PAIR(2)));
	rcck(13,addch('	'));
	rcck(14,move(yy-2,j));
	rcck(15,attrset(COLOR_PAIR(3)));
	rcck(16,addch('	'));
	rcck(17,move(yy-1,j));
	rcck(18,attrset(COLOR_PAIR(4)));
		addch('	');
    }
}

int s5cur( struct passed *myparam )
{
    int	qch;
    int	j,k,n,m,o,nmax,mmax,newch;
    int	chbuild=0, chcnt=0;
    int	junk;
    int	mouseinfo[5];
    char csave;

// fprintf(stdout,"myparm todo=	%d \n",myparam->todo);

    x =	myparam->x; xx = myparam->xx; xmax = myparam->xmax;
    y =	myparam->y; yy = myparam->yy; ymax = myparam->ymax;
//fprintf(stdout,"case start x=%d y=%d xx=%d yy=%d\n",x,y,xx,yy);

    switch (myparam->todo) {
    case 0:			// initialize
//fprintf(stdout,"BUTTON1_RELEASED=%d \n",BUTTON1_RELEASED);
//fprintf(stdout,"BUTTON1_PRESSED=%d \n",BUTTON1_PRESSED);
//fprintf(stdout,"BUTTON1_CLICKED=%d \n",BUTTON1_CLICKED);
//fprintf(stdout,"BUTTON2_RELEASED=%d \n",BUTTON2_RELEASED);
//fprintf(stdout,"BUTTON2_PRESSED=%d \n",BUTTON2_PRESSED);
//fprintf(stdout,"BUTTON2_CLICKED=%d \n",BUTTON2_CLICKED);
//fprintf(stdout,"BUTTON3_RELEASED=%d \n",BUTTON3_RELEASED);
//fprintf(stdout,"BUTTON3_PRESSED=%d \n",BUTTON3_PRESSED);
//fprintf(stdout,"BUTTON3_CLICKED=%d \n",BUTTON3_CLICKED);

//####	fprintf(stdout,"initializing pdcurses \n");
	myscreen=initscr();
	rcck(21,raw());
	rcck(22,noecho());
	rcck(22,keypad(stdscr,TRUE));
	rcck(222,PDC_return_key_modifiers(TRUE));
	getmaxyx(stdscr,ymax,xmax);
// fprintf(stdout,"init	xmax=%d	ymax=%d\n",xmax,ymax);
	myparam->xmax=xmax;  myparam->ymax=ymax;
// fprintf(stdout,"xmax	= %d ymax = %d \n",xmax,ymax);

	if (can_change_color())	{ // fprintf(stdout,"can change	colors\n");
	    rcck(24,start_color());
	    rcck(25,init_color(COLOR_BLUE,0,0,250));
	    rcck(25,init_color(COLOR_WHITE,1000,1000,1000));
	    rcck(25,init_color(COLOR_RED,750,0,0));
//	} else {
//	    fprintf(stdout,"####cannot change colors\n");
	}

	if (has_colors()) {
	    rcck(26,start_color());
	    rcck(27,init_pair(1,COLOR_WHITE  ,COLOR_BLUE)); // main text region
	    rcck(28,init_pair(2,COLOR_WHITE ,COLOR_GREEN)); // command line region
	    rcck(29,init_pair(3,COLOR_WHITE ,COLOR_BLACK)); // info region
	    rcck(30,init_pair(4,COLOR_RED   ,COLOR_BLACK)); // error msg region
	    rcck(31,init_pair(5,COLOR_WHITE   ,COLOR_RED)); // marked region
	    rcck(32,init_pair(6,COLOR_YELLOW,COLOR_BLACK)); // borders
	}

	mousemask(7399,&junk);	 // look for buttons left/right	press, click and release
	break;

    case 1:			// finish initialize
	subinit();		// redraw background for pane
	curs_set(myparam->cur +	1);
	break;

    case 2:					// read	keystroke
	readagain:
	qch = getch();
	if (PDC_get_key_modifiers() & PDC_KEY_MODIFIER_ALT) {
	  qch =	qch + 1024;
	}
	if (PDC_get_key_modifiers() & PDC_KEY_MODIFIER_CONTROL)	{
	  qch =	qch + 2048;
	}
	if (PDC_get_key_modifiers() & PDC_KEY_MODIFIER_SHIFT) {
	  qch =	qch + 4096;
	}
//	if (PDC_get_key_modifiers() & PDC_KEY_MODIFIER_NUMLOCK)	{
//	  qch =	qch + 8192;
//	}
	if (qch>=540 & qch<=545) { goto	readagain; } //	stand alone alt,ctrl,shift

	if (qch	== 13) { qch=13000; } // make enter key	not look like a	character
	if (qch	== 27) { qch=27000; } // make esc key not look like a character

// following is	to let alt-shift 3 digit number	enter a	character code (000-255)
if (qch==5153) {chbuild	= chbuild * 10 + 1; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5155) {chbuild	= chbuild * 10 + 3; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5156) {chbuild	= chbuild * 10 + 4; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5157) {chbuild	= chbuild * 10 + 5; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5158) {chbuild	= chbuild * 10 + 7; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5160) {chbuild	= chbuild * 10 + 9; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5161) {chbuild	= chbuild * 10 + 0; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5162) {chbuild	= chbuild * 10 + 8; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5184) {chbuild	= chbuild * 10 + 2; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
if (qch==5214) {chbuild	= chbuild * 10 + 6; chcnt++; if(chcnt<3) {goto readagain;} chcnt=0; qch=chbuild; chbuild=0; if(qch>255)	{goto readagain;}}
	chcnt =	0; chbuild = 0;

	myparam->key = qch;
//	fprintf(stdout,"qch= %d	%d \n",myparam->key,qch);

	switch (qch) {
	case KEY_RESIZE:      // do special handling here only for resize
	    resizech:			    // user should do case 1 calls after this
	    timeout(100);
	    newch = getch(); //	see if getting multiple	resizes
	    if (newch==KEY_RESIZE) {
		goto resizech;
	    } else {
		if (newch!=ERR)	{
		    rcck(60,ungetch(newch));
		}
	    }
	    timeout(-1);

	    resizeagain:

	    rcck(37,resize_term(0, 0));
	    rcck(50,move(0,0));
	    rcck(55,clear());
	    rcck(38,bkgd(' ' | COLOR_PAIR(1)));
	    getmaxyx(stdscr,nmax,mmax);
	    myparam->xmax=mmax;	 myparam->ymax=nmax;
	    getmaxyx(stdscr,nmax,mmax);
	    if (nmax!=myparam->ymax) {
		goto resizeagain;
	    }
	    if (mmax!=myparam->xmax) {
		goto resizeagain;
	    }
	    break;
	default:
	    break;
	}
	refresh();
	myparam->key=qch;      // return key stroke code
	break;

    case 3:		// move	cursor to x,y and set cursor size if cur!=0
	rcck(41,move(y,x));
	curs_set(myparam->cur +	1);
	refresh();
	break;

    case 5:		// reverse color for character at x,y
	o = xlat[(unsigned char) myparam->towrite[0]];
	if (o!=0) {o = o + 65536;} else	{ o=myparam->towrite[0]; }
	rcck(412,mvaddch(y,x,A_REVERSE | o));
	refresh();
	break;

    case 4:	 // write a character string at	x,y and	set color if col!=0
	// otherwise sets color	per pane parameters
	// sets	col to zero afterwards
//fprintf(stdout,"case 4 length= %d string ='",myparam->len);
// for (j=0;j<myparam->len;j++)	{
//  fprintf(stdout,"%c",myparam->towrite[j]);
// }
// fprintf(stdout,"'\n");
	if (myparam->col!=0) {
	    attrset(COLOR_PAIR(myparam->col));
	} else {
	    if (y<yy-3)	{
		rcck(34,attrset(COLOR_PAIR(1)));
	    } else {
		rcck(35,attrset(COLOR_PAIR(y+5-yy)));
	    }
	}

	if (rcck(501,move(y,x))) {
	    fprintf(stdout,"501	x=%d y=%d\n",x,y);
	}
	if ((x+myparam->len)>myparam->xmax) {
	    fprintf(stdout,"502	x=%d len=%d xmax=%d\n",x,myparam->len,myparam->xmax);
	}

	m=0;	// start of string
	for(n=m;n<myparam->len;n++) {
	  o = xlat[(unsigned char) myparam->towrite[n]];
	  if (o!=0) {
	   if (n>m) { // if there it is	not a null string before offset	n
	    csave=myparam->towrite[n]; // save following char
	    myparam->towrite[n]=0; // put in trailing zero
	    rcck(36,addstr(&myparam->towrite[m]));
	    myparam->towrite[n]=csave; // restore that byte
	   }
	   rcck(366,addch(o+65536));	// write the special character
	   m=n+1; // offset of character after one we did
	  }
	}
	if (n>m) {
	 csave=myparam->towrite[n]; // save following char
	 myparam->towrite[n]=0;	// put in trailing zero
	 rcck(36,addstr(&myparam->towrite[m]));
	 myparam->towrite[n]=csave; // restore that byte
	}

	break;

    case 6:  //	mouse input
	nc_getmouse((MEVENT *) &mouseinfo);
	myparam->xmax=mouseinfo[1];
	myparam->ymax=mouseinfo[2];
	myparam->key=mouseinfo[4];
	break;

    case 10: //	draw boxes for split screens
	attrset(COLOR_PAIR(6));	// use yellow
// fprintf(stdout,"case	10 x=%d	y=%d xx=%d yy=%d\n",x,y,xx,yy);
	for (j=x;j<=xx;j++) {
	    for	(k=y;k<=yy;k++)	{
	      if(k<ymax	& j<xmax & k>=0	& j>=0)	{
		if (j==x & k!=y) {
		    move(k,j); addch(ACS_VLINE);
		}
		if (j==xx & k!=y) {
		    move(k,j); addch(ACS_VLINE);
		}
		if (j!=x & k==y) {
		    move(k,j); addch(ACS_HLINE);
		}
		if (j!=x & k==yy) {
		    move(k,j); addch(ACS_HLINE);
		}

		if (j==x & k==y) {
		    move(k,j); addch(ACS_ULCORNER);
		}
		if (j==x & k==y	 & j!=0	& k==0)	{
		    move(k,j); addch(ACS_TTEE);
		}
		if (j==x & k==y	 & j==0	& k!=0)	{
		    move(k,j); addch(ACS_LTEE);
		}
		if (j==xx & k==y) {
		    move(k,j); addch(ACS_URCORNER);
		}
		if (j==xx & k==y & j!=xmax-1 & k==0) {
		    move(k,j); addch(ACS_TTEE);
		}
		if (j==xx & k==y & j==xmax-1 & k!=0) {
		    move(k,j); addch(ACS_RTEE);
		}
		if (j==x & k==yy) {
		    move(k,j); addch(ACS_LLCORNER);
		}
		if (j==x & k==yy & j!=0	& k==ymax-1) {
		    move(k,j); addch(ACS_BTEE);
		}
		if (j==x & k==yy & j==0	& k!=ymax-1) {
		    move(k,j); addch(ACS_LTEE);
		}
		if (j==xx & k==yy) {
		    move(k,j); addch(ACS_LRCORNER);
		}
		if (j==xx & k==yy & j!=xmax-1 &	k==ymax-1) {
		    move(k,j); addch(ACS_BTEE);
		}
		if (j==xx & k==yy & j==xmax-1 &	k!=ymax-1) {
		    move(k,j); addch(ACS_RTEE);
		}

		if (j==x & k==y	& j!=0 & k!=0 )	{
		    move(k,j); addch(ACS_PLUS);
		}
		if (j==xx & k==y & j!=xmax-1 & k!=0) {
		    move(k,j); addch(ACS_PLUS);
		}
		if (j==x & k==yy & j!=0	& k!=ymax-1) {
		    move(k,j); addch(ACS_PLUS);
		}
		if (j==xx & k==yy & j!=xmax-1 &	k!=ymax-1) {
		    move(k,j); addch(ACS_PLUS);
		}
	      }
	    }
	}
	break;

    case 93:
	mousemask(0,&junk);   // look for no mouse things
	break;

    case 94:
	rcck(90,reset_shell_mode());
	break;

    case 95:
	rcck(92,reset_prog_mode());
	break;

    case 97:
	refresh();
	break;

    case 98:
	mousemask(7399,&junk);	 // look for buttons left/right	press, click and release
	break;

    case 99:
	rcck(42,endwin());	 // also turns off mouse capture
	break;

    default:
	fprintf(stdout,"####unknown pe3	case %d	\n",myparam->todo);
	break;

    }


    return(0);
}

